Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/AppletAction.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/AppletAction.java	(revision 26132)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/AppletAction.java	(revision 26133)
@@ -98,4 +98,7 @@
 		page_response.appendChild(service_elem);
 
+		//append site metadata
+		addSiteMetadata(page_response, userContext);
+		//addInterfaceOptions(page_response);
 		return result;
 
Index: /main/trunk/greenstone3/web/interfaces/default/interfaceConfig.xml
===================================================================
--- /main/trunk/greenstone3/web/interfaces/default/interfaceConfig.xml	(revision 26132)
+++ /main/trunk/greenstone3/web/interfaces/default/interfaceConfig.xml	(revision 26133)
@@ -16,5 +16,5 @@
     <action class="DocumentAction" name="d" xslt="pages/document.xsl"/>
 
-    <action class="AppletAction" name="a" xslt="applet.xsl"/>
+    <action class="AppletAction" name="a" xslt="pages/applet.xsl"/>
     <action class="XMLDocumentAction" name="xd">
       <subaction name="toc" xslt="pages/document-toc.xsl"/>
Index: /main/trunk/greenstone3/web/interfaces/default/transform/layouts/header.xsl
===================================================================
--- /main/trunk/greenstone3/web/interfaces/default/transform/layouts/header.xsl	(revision 26132)
+++ /main/trunk/greenstone3/web/interfaces/default/transform/layouts/header.xsl	(revision 26133)
@@ -147,6 +147,31 @@
 				</xsl:if>
 
+				<!-- PhindApplet. Need something similar for the Collage applet too, probably -->
+				<xsl:for-each select="/page/pageResponse/collection[@name=$collNameChecked]/serviceList/service[@name='PhindApplet']">
+					<li>
+						<xsl:choose>
+							<!-- If this tab is selected then colour it differently -->
+							<xsl:when test="/page/pageRequest[@action='a']">
+								<xsl:attribute name='class'>ui-state-default ui-corner-top ui-tabs-selected ui-state-active</xsl:attribute>
+							</xsl:when>
+							<xsl:otherwise>
+								<xsl:attribute name='class'>ui-state-default ui-corner-top</xsl:attribute>
+							</xsl:otherwise>
+						</xsl:choose>
+						
+						<a>
+							<xsl:if test="displayItem[@name='description']">
+								<xsl:attribute name="title">
+									<xsl:value-of select="displayItem[@name='description']"/>
+								</xsl:attribute>
+							</xsl:if>						  
+							<xsl:attribute name="href"><xsl:value-of select="$library_name"/>?a=a&amp;rt=d&amp;s=<xsl:value-of select="@name"/>&amp;c=<xsl:value-of select="/page/pageResponse/collection/@name"/></xsl:attribute>
+							<xsl:value-of select="displayItem[@name='name']"/>
+						</a>
+					</li>
+				</xsl:for-each>
+				
 				<!-- all other services -->
-				<xsl:for-each select="/page/pageResponse/collection[@name=$collNameChecked]/serviceList/service[not(@type='query') and not(@type='browse')]">
+				<xsl:for-each select="/page/pageResponse/collection[@name=$collNameChecked]/serviceList/service[not(@type='query') and not(@type='browse') and not (@name='PhindApplet')]">
 					<xsl:call-template name="navigationTab"/>
 				</xsl:for-each>
Index: /main/trunk/greenstone3/web/interfaces/default/transform/pages/applet.xsl
===================================================================
--- /main/trunk/greenstone3/web/interfaces/default/transform/pages/applet.xsl	(revision 26133)
+++ /main/trunk/greenstone3/web/interfaces/default/transform/pages/applet.xsl	(revision 26133)
@@ -0,0 +1,26 @@
+<?xml version="1.0" encoding="ISO-8859-1"?>
+<xsl:stylesheet version="1.0"
+	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
+	xmlns:java="http://xml.apache.org/xslt/java"
+	xmlns:util="xalan://org.greenstone.gsdl3.util.XSLTUtil"
+	xmlns:gslib="http://www.greenstone.org/skinning"
+	extension-element-prefixes="java util"
+	exclude-result-prefixes="java util">
+
+	<!-- use the 'main' layout -->
+	<xsl:include href="layouts/main.xsl"/>
+
+	<!-- set page title -->
+	<xsl:template name="pageTitle">The Phind Applet<!--<gslib:collectionName/><xsl:value-of select="/page/pageResponse/service/applet"/>--></xsl:template>
+
+	<!-- set page breadcrumbs -->
+	<xsl:template name="breadcrumbs"><gslib:siteLink/><gslib:rightArrow/><gslib:collectionNameLinked/><gslib:rightArrow/></xsl:template>
+
+	<!-- the main page layout template is here -->
+	<xsl:template match="/page/pageResponse">
+    	<div class="phrasebrowse">
+			<xsl:copy-of select="service/applet"/>
+		</div>
+	</xsl:template>
+</xsl:stylesheet>  
+